static char * get_mem_00000_003ff(uWORD addr)            /* rd_mem */
{
        return(mem.rd_ram + addr);
}

static char * get_mem_03f00_03fff(uWORD addr)            /* rd_reg */
{
        return(mem.rd_reg + (addr & 0x000fffff));
}

static char * get_mem_04000_04001(uWORD addr)            /* sp_dmem */
{
        return(mem.sp_dmem + (addr & 0xfff));
}

static char * get_mem_04001_04002(uWORD addr)            /* sp_imem */
{
        return(mem.sp_imem + (addr & 0xfff));
}

static char * get_mem_04040_04040(uWORD addr)            /* sp_reg (20bytes) */
{
        if(addr < 0x04040020)
                return(mem.sp_reg + (addr & 0xff));
        else
                return(mem.null_mem);
}

static char * get_mem_04080_04080(uWORD addr)            /* sp pc & ibist reg  (8bytes) */
{
        if(addr < 0x04080004)
                return(((char *)&(mem.sp_reg_pc)) + (addr & 0x03));
        if(addr < 0x04080008)
                return(((char *)&(mem.sp_reg_ibist)) + addr - 0x04080004);

        /* else */
        return(mem.null_mem);
}

static char * get_mem_04100_04100(uWORD addr)            /* dpc_reg (32bytes) */
{
        if(addr < 0x04100020)
                return(mem.dpc_reg + (addr & 0xff));
        else
                return(mem.null_mem);
}

static char * get_mem_04200_04200(uWORD addr)            /* dps_reg (16bytes) */
{
        if(addr < 0x04200010)
                return(mem.dps_reg + (addr & 0xff));
        else
                return(mem.null_mem);
}

static char * get_mem_04300_04300(uWORD addr)            /* mi_reg (16bytes) */
{
        if(addr < 0x04300010)
                return(mem.mi_reg + (addr & 0xff));
        else
                return(mem.null_mem);
}

static char * get_mem_04400_04400(uWORD addr)            /* vi_reg (56bytes) */
{
        static sWORD    current_verical_line = -1;

        if(addr >= 0x04400010 && addr <= 0x04400013)
        {       
                if(current_verical_line < 512)
                        current_verical_line += 2;
                else
                        current_verical_line = 0;

                return(((char *)&current_verical_line) + (addr & 0x03));

        }

        if(addr < 0x04400038)
                return(mem.vi_reg + (addr & 0xff));
        else
                return(mem.null_mem);
}

static char * get_mem_old(uWORD addr)                    /* old_method */
{
        return(phys_read_addr(addr));
}

static char * put_mem_old(uWORD addr)                    /* old_method */
{
        return(phys_write_addr(addr));
}





static void init_fast_mem()
{
        int i;

        for(i=0; i<0x400; i++)
        {
                phys_read_fast[i] = get_mem_00000_003ff;
                phys_write_fast[i] = get_mem_00000_003ff;
        }
        for(i=0x400; i<0x20000; i++)
        {
                phys_read_fast[i] = get_mem_old;
                phys_write_fast[i] = put_mem_old;
        }
}



