/**
 * TrueReality - file_loader.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>

#include <GL/gl.h>
#include <GL/glu.h>

#include "display.h"
#include <memory_extern.h>
#include "../../n64/rdp_registers.h"

uWORD flags;	
HWND HWNDMss;
void msg_box(char *textl)
{
	MessageBox(HWNDMss, textl, "Display", MB_OK);
}


int RePaint;				// are used by DEBUG.cpp and MAIN.cpp
extern int iRenderWindowX;
extern int iRenderWindowY;
extern int DrawBackground;


void DrawScreenGL(unsigned int width, unsigned int height);
//********************************************************************************
//** Init Stuff																	**
//********************************************************************************

int OpenVisual()
{
	return 0;
}
int CloseVisual()
{
	return 0;
}
void GetVisualName(char *name, int *n)
{
}
void SetVisualTitle(char *name)
{
}

//********************************************************************************
//** For 2d-demos only, very, very, 'uncool' hack							    **
//********************************************************************************

void RefreshVisual()
{
	uWORD    width, height;
	if (DrawBackground == 1)
	{
		width = ((uWORD *)mem.vi_reg)[2];
		height = (width * 3) >> 2;
		if ((width == 0) || (height == 0)) return;
		DrawScreenGL(256, 256);
		RePaint = 1;
	}
} 

/* This will draw the current n64 frame buffer to the screen */
/* At the moment only 15 bit graphics at a resolution of 320*240 is supported. */
/* It probably only works right with big endian at the momment. */
/* This routine was coded by Gil Pedersen */

static unsigned char tbuffer[256*256*4];
void DrawScreenGL(unsigned int width, unsigned int height)
{
	unsigned long i, j;

	uHWORD *src, *base_src_ptr;
	unsigned char *dest;
	GLint hadDepthTest, hadBlending;

	glGetIntegerv(GL_DEPTH_TEST, &hadDepthTest); //** Should be glGetBooleanv, but 
	glDisable(GL_DEPTH_TEST);
	glGetIntegerv(GL_BLEND, &hadBlending); //** Should be glGetBooleanv, but 
	glDisable(GL_BLEND);

    glMatrixMode(GL_PROJECTION);
	glPushMatrix();
    glLoadIdentity();
	glOrtho(0, width, height-1.2, 0, -1, 1);
    glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
    glLoadIdentity();

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

	glEnable(GL_TEXTURE_2D);

    base_src_ptr = (uHWORD*)(uWORD*)(mem.rd_ram + ((uWORD*)mem.vi_reg)[1]);
//	DecompressTexture(((uWORD*)mem.vi_reg)[1], 0, 0, 256, 256, 2);

		dest = (unsigned char*)tbuffer;	
		for(i=0; i<height; i++)
		{			
			for(j=0; j<width; j++)
			{				
				src = base_src_ptr + i*320 + j;
				*(dest) = (((*src >> 11 ) & 0x001f)<<3); dest++;
				*(dest) = (((*src >>  6 ) & 0x001f)<<3); dest++;
				*(dest) = (((*src >>  1 ) & 0x001f)<<3); dest++;
				*(dest) = 0xff; dest++;  //** Alpha

			}
		}
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 256, 256, 0, GL_RGBA, 
		GL_UNSIGNED_BYTE, tbuffer);

		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex2f(  0.0,   0.0);
			glTexCoord2f(0.0, 1.0); glVertex2f(  0.0,   256.0);			
			glTexCoord2f(1.0, 1.0); glVertex2f(  256.0, 256.0);
			glTexCoord2f(1.0, 0.0); glVertex2f(  256.0,   0.0);
		glEnd();

	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
    glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	if (hadBlending) glEnable(GL_BLEND);
	if (hadDepthTest) glEnable(GL_DEPTH_TEST);
}



void FlushVisualRenderBuffer(void)
{
	RePaint = 1;
}
